Summary: A SQL database engine
Name: mysql
Group: Environment/Databases
Version: 3.23.58
Release: 3tr
License: GPL / LGPL
%define db_version		3.2.9a
%define shared_libversion	10:0:0
%define mysqld_user		mysql
Source: ftp://sunsite.dk/mirrors/mysql/Downloads/MySQL-3.23/mysql-%{version}.tar.gz
Source1: http://download.sourceforge.net/pub/mirrors/mysql/Downloads/db/db-%{db_version}.tar.gz
Source2: mysql.init
Patch0: mysql-4.0.18-tempfile.patch
Patch1: mysql-3.23.58-CAN-2004-0835.patch
Patch2: mysql-3.23.58-CAN-2004-0836.patch
Patch3: mysql-3.23.58-CAN-2004-0837.patch
URL: http://www.mysql.com/
Provides: msqlormysql MySQL-server
Buildroot: /var/tmp/%{name}-root
Prereq: /bin/hostname /bin/sleep /sbin/chkconfig /sbin/restart_maybe
%define see_base For a description of MySQL see the base MySQL RPM or http://www.mysql.com


# From the manual
%description
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.

The main goals of MySQL are speed, robustness and ease of use.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many
years. While MySQL is still in development, it already offers a rich
and highly useful function set.

See the documentation for more information

%package client
Release: %{release}
Summary: MySQL - Client
Group: Environment/Databases
Obsoletes: mysql-client

%description client
This package contains the standard MySQL clients. 

%{see_base}

%package bench
Release: %{release}
## Requires: mysql-client MySQL-DBI-perl-bin perl
Requires: mysql-client perl
Summary: MySQL - Benchmarks and test system
Group: Environment/Databases
Obsoletes: mysql-bench

%description bench
This package contains MySQL benchmark scripts and data.

%{see_base}

%package devel
Release: %{release}
Requires: mysql-client
Summary: MySQL - Development header files and libraries
Group: Libraries/Development
Obsoletes: mysql-devel

%description devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%{see_base}

%package shared
Release: %{release}
Summary: MySQL - Shared libraries
Group: Libraries/Runtime

%description shared
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%prep
%setup -q -n %{name}-%{version} -a 1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
# The all-static flag is to make the RPM work on different
# distributions. This version tries to put shared mysqlclient libraries
# in a separate package.

BuildMySQL() {
# The --enable-assembler simply does nothing on systems that does not
# support assembler speedups.
sh -c  "PATH=\"${MYSQL_BUILD_PATH:-/bin:/usr/bin}\" \
	CC=\"${MYSQL_BUILD_CC:-gcc}\" \
	CFLAGS=\"${MYSQL_BUILD_CFLAGS:- $RPM_OPT_FLAGS}\" \
	CXX=\"${MYSQL_BUILD_CXX:-gcc}\" \
	CXXFLAGS=\"${MYSQL_BUILD_CXXFLAGS:- $RPM_OPT_FLAGS \
	          -felide-constructors -fno-exceptions -fno-rtti}\" \
	./configure \
 	    $* \
	    --enable-assembler \
            --with-mysqld-user=%{mysqld_user} \
            --with-unix-socket-path=/var/lib/mysql/mysql.sock \
            --prefix=/ \
	    --with-extra-charsets=complex \
            --exec-prefix=/usr \
            --libexecdir=/usr/sbin \
            --sysconfdir=/etc \
            --datadir=/usr/share \
            --localstatedir=/var/lib/mysql \
            --infodir=/usr/share/info \
            --includedir=/usr/include \
            --mandir=/usr/share/man \
	    --with-berkeley-db \
	    --with-comment=\"Trustix MySQL RPM\";
	    # Add this for more debugging support
	    # --with-debug
	    # Add this for MyISAM RAID support:
	    # --with-raid
	    "

 # benchdir does not fit in above model. Maybe a separate bench distribution
 make benchdir_root=$RPM_BUILD_ROOT/usr/share/
}

# Use the build root for temporary storage of the shared libraries.

RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{version}
mkdir -p $RPM_BUILD_ROOT || :

BuildMySQL "--enable-shared --enable-thread-safe-client --without-server"

# Save everything for debus
tar cf $RBR/all.tar .

# Save shared libraries
(cd libmysql/.libs; tar cf $RBR/shared-libs.tar *.so*)
(cd libmysql_r/.libs; tar rf $RBR/shared-libs.tar *.so*)

# Save manual to avoid rebuilding
mv Docs/manual.ps Docs/manual.ps.save
make distclean
mv Docs/manual.ps.save Docs/manual.ps

BuildMySQL "--disable-shared" \
	   "--with-mysqld-ldflags='-all-static'" \
	   "--with-client-ldflags='-all-static'"

%install -n mysql-%{version}
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{version}
# Ensure that needed directories exists
install -d $RBR/etc/{logrotate.d,rc.d/init.d}
install -d $RBR/var/lib/mysql/mysql
install -d $RBR/usr/share/sql-bench
install -d $RBR/usr/share/mysql-test
install -d $RBR/usr/{sbin,share,man,include}
install -d $RBR/usr/doc/MySQL-%{version}
install -d $RBR/usr/lib
# Make install
make install DESTDIR=$RBR benchdir_root=/usr/share/

# Install shared libraries (Disable for architectures that don't support it)
(cd $RBR/usr/lib; tar xf $RBR/shared-libs.tar)

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate $RBR/etc/logrotate.d/mysql
install -m755 %{SOURCE2} $RBR/etc/rc.d/init.d/mysql

# Install docs
install -m644 $RPM_BUILD_DIR/mysql-%{version}/Docs/mysql.info \
 $RBR/usr/share/info/mysql.info

%clean
rm -rf $RPM_BUILD_ROOT

%pre
if test -x /etc/rc.d/init.d/mysql
then
  /etc/rc.d/init.d/mysql stop > /dev/null 2>&1
  echo "Giving mysqld a couple of seconds to exit nicely"
  sleep 5
fi

%post
mysql_datadir=/var/lib/mysql

# Create data directory if needed
if test ! -d $mysql_datadir;		then mkdir $mysql_datadir; fi
if test ! -d $mysql_datadir/mysql;	then mkdir $mysql_datadir/mysql; fi
if test ! -d $mysql_datadir/test;	then mkdir $mysql_datadir/test; fi

# Add mysql to the chkconfig overview
/sbin/chkconfig --add mysql

# Check whether we need to add mysql user
if [ ! "`getent passwd mysql`" ] ; then
        /usr/sbin/useradd  -u 101 -m -d $mysql_datadir \
	-s /bin/bash -c "MySQL server" mysql
fi

# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R mysql $mysql_datadir

# Initiate databases
mysql_install_db -IN-RPM

# Change permissions again to fix any new files.
chown -R mysql $mysql_datadir

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql

# Restart in the same way that mysqld will be started normally.
/sbin/restart_maybe mysql

# Allow safe_mysqld to start mysqld and print a message before we exit
sleep 2

%preun
# Remove autostart of mysql
if test $1 = 0
then
   /etc/rc.d/init.d/mysql stop > /dev/null
   /sbin/chkconfig --del mysql
fi
# We do not remove the mysql user since it may still own a lot of
# database files.

%files
## %attr(-, root, root) %doc /usr/doc/MySQL-%{version}/
%doc README COPYING COPYING.LIB Docs/manual_toc.html Docs/manual.html 
%doc Docs/manual.txt Docs/manual.texi Docs/manual.ps support-files/my-huge.cnf 
%doc support-files/my-large.cnf support-files/my-medium.cnf 
%doc support-files/my-small.cnf

%attr(755, root, root) /usr/bin/isamchk
%attr(755, root, root) /usr/bin/isamlog
%attr(755, root, root) /usr/bin/pack_isam
%attr(755, root, root) /usr/bin/myisamchk
%attr(755, root, root) /usr/bin/myisamlog
%attr(755, root, root) /usr/bin/myisampack
%attr(755, root, root) /usr/bin/mysql_fix_privilege_tables
%attr(755, root, root) /usr/bin/mysql_convert_table_format
%attr(755, root, root) /usr/bin/mysql_install_db
%attr(755, root, root) /usr/bin/mysql_setpermission
%attr(755, root, root) /usr/bin/mysql_zap
%attr(755, root, root) /usr/bin/mysqlbug
%attr(755, root, root) /usr/bin/mysqltest
%attr(755, root, root) /usr/bin/mysqlhotcopy
%attr(755, root, root) /usr/bin/perror
%attr(755, root, root) /usr/bin/replace
%attr(755, root, root) /usr/bin/resolveip
%attr(755, root, root) /usr/bin/safe_mysqld
%attr(755, root, root) /usr/bin/mysqld_multi
%attr(755, root, root) /usr/bin/my_print_defaults

%attr(644, root, root) /usr/share/info/mysql.info*

%attr(755, root, root) /usr/sbin/mysqld

%attr(644, root, root) /etc/logrotate.d/mysql
%attr(755, root, root) /etc/rc.d/init.d/mysql

%attr(755, root, root) /usr/share/mysql/

%files client
%attr(755, root, root) /usr/bin/msql2mysql
%attr(755, root, root) /usr/bin/mysql
%attr(755, root, root) /usr/bin/mysqlaccess
%attr(755, root, root) /usr/bin/mysqladmin
%attr(755, root, root) /usr/bin/mysql_find_rows
%attr(755, root, root) /usr/bin/mysqldump
%attr(755, root, root) /usr/bin/mysqlimport
%attr(755, root, root) /usr/bin/mysqlshow
%attr(755, root, root) /usr/bin/mysqlbinlog
%attr(644, root, man) /usr/share/man/man1/*

%post shared
/sbin/ldconfig

%postun shared
/sbin/ldconfig

%files devel
%attr(755, root, root) /usr/bin/comp_err
%attr(755, root, root) /usr/include/mysql/
%attr(755, root, root) /usr/lib/mysql/
%attr(755, root, root) /usr/bin/mysql_config

%files shared
# Shared libraries (omit for architectures that don't support them)
%attr(755, root, root) /usr/lib/*.so*

%files bench
%attr(-, root, root) /usr/share/sql-bench
%attr(-, root, root) /usr/share/mysql-test

%changelog 
* Fri Oct 15 2004 Oystein Viggen <oysteivi at trustix dot com> 3.23.58-3tr
- Patch security issues: CAN-2004-0835, CAN-2004-0836, CAN-2004-0837

* Tue Sep 28 2004 Oystein Viggen <oysteivi at trustix dot com>
- Patch tempfile issue

* Tue Sep 16 2003 Erlend Midttun <erlendbm@trustix.com> 3.23.58-1tr
- New upstream.

* Tue Jul  1 2003 Erlend Midttun <erlendbm@trustix.com> 3.23.57-1tr
- New upstream.

* Tue Mar 18 2003 Erlend Midttun <erlendbm@trustix.com> 3.23.56-1tr
- Upgraded to fix security holes.

* Thu Feb 20 2003 Erlend Midttun <erlendbm@trustix.com> 3.23.55-1tr
- Upgraded to fix security holes.

* Tue Dec 17 2002 Erlend Midttun <erlendbm@trustix.com>
- Upgraded to fix security holes.

* Fri Mar 15 2002 Christian H. Toldnes <christht@trustix.com>
- Rebuild on new zlib, due to broken old one.

* Fri Jan  4 2002 Christian H. Toldnes <christht@trustix.com>
- New upstream version: 3.23.47
- Now calls stop only once on upgrade.
- Added %clean, general package cleanup.

* Tue Jun  5 2001 Oystein Viggen <oysteivi@trustix.com>
- New upstream version: 3.23.28

* Wed Mar 28 2001 Alexander Reelsen <ar@trustix.com>
- Updated to 3.23.36, security fix

* Mon Mar 26 2001 Alexander Reelsen <ar@trustix.com>
- Fixed init script problems

* Mon Feb 19 2001 Oystein Viggen <oysteivi@trustix.com>
- Adapt to TSL

* Tue Jan 2  2001  Monty

- Added mysql-test to the bench package

* Fri Aug 18 2000 Tim Smith <tim@mysql.com>

- Added separate libmysql_r directory; now both a threaded
  and non-threaded library is shipped.

* Wed Sep 28 1999 David Axmark <davida@mysql.com>

- Added the support-files/my-example.cnf to the docs directory.

- Removed devel dependency on base since it is about client
  development.

* Wed Sep 8 1999 David Axmark <davida@mysql.com>

- Cleaned up some for 3.23.

* Thu Jul 1 1999 David Axmark <davida@mysql.com>

- Added support for shared libraries in a separate sub
  package. Original fix by David Fox (dsfox@cogsci.ucsd.edu)

- The --enable-assembler switch is now automatically disables on
  platforms there assembler code is unavailable. This should allow
  building this RPM on non i386 systems.

* Mon Feb 22 1999 David Axmark <david@detron.se>

- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.

- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.

- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>

- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>

- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.
